#include "stdafx.h"
#include "ModelViewerRenderer.h"


CModelViewerRenderer::CModelViewerRenderer() :
	m_bRotation(true),
	m_bPan(true),
	m_bZoom(true),
	m_bRenderPoint(true),
	m_bRenderLine(true),
	m_bRenderFace(true),
	m_bPickPoint(true),
	m_bPickLine(true),
	m_bPickFace(true)
{
}


CModelViewerRenderer::~CModelViewerRenderer()
{
}

bool CModelViewerRenderer::DoTracking( POINT point )
{
	if( (TM_ROTATION == m_eTrackingMode && !m_bRotation)
	 || (TM_PAN == m_eTrackingMode && !m_bPan)
	 || (TM_ZOOM == m_eTrackingMode && !m_bZoom) )
	{       // ȃ}EXΉ
		return false;
	}

	// eNX̊֐̌Ăяo
	return COpenGLRendererPick::DoTracking( point );
}

void CModelViewerRenderer::RenderModel( ERENDERMODE eRenderMode )
{
	unsigned int uiCountPoint = 8;
	float points[8][3] = { -5, -5, -5,
							  5, -5, -5,
							  5,  5, -5,
							 -5,  5, -5,
							 -5, -5,  5,
							  5, -5,  5,
							  5,  5,  5,
							 -5,  5,  5 };
	unsigned int uiCountTriangle = 12;
	unsigned int triangles[12][3] = { 0, 1, 3,
							  1, 2, 3,
							  1, 5, 2,
							  5, 6, 2,
							  5, 4, 6,
							  4, 7, 6,
							  4, 0, 7,
							  0, 3, 7,
							  3, 2, 7,
							  2, 6, 7,
							  4, 5, 0,
							  5, 1, 0 };
	unsigned int uiIndexTriangle;
	unsigned int uiIndexLine;
	unsigned int uiIndexPoint;
	unsigned int ui3;

	glPushAttrib( GL_ALL_ATTRIB_BITS );	// Agr[gAł悤ɁAǉ

	// 
	if( m_bRenderFace )
	{
		if( RM_RENDER == eRenderMode )
		{
			glColor3f( 0.5f, 0.5f, 0.0f );
		}
		if( RM_PICK_ELEMENTTYPE == eRenderMode )
		{
			glColor3f( 1.0f, 0.0f, 0.0f );
		}
		for( uiIndexTriangle = 0; uiIndexTriangle < uiCountTriangle; uiIndexTriangle++ )
		{
			if( RM_PICK_ELEMENTID == eRenderMode )
			{
				glColor3ub( GetRValue(uiIndexTriangle), GetGValue(uiIndexTriangle), GetBValue(uiIndexTriangle) );
			}
			glBegin( GL_TRIANGLES );
			glVertex3fv( points[triangles[uiIndexTriangle][0]] );
			glVertex3fv( points[triangles[uiIndexTriangle][1]] );
			glVertex3fv( points[triangles[uiIndexTriangle][2]] );
			glEnd();
		}
		// sbNʂ̕`
		if( RM_RENDER == eRenderMode )
		{
			if( RET_FACE == m_auiName_picked[1] )
			{
				uiIndexTriangle = m_auiName_picked[2];
				glColor3f( 1.0f, 1.0f, 0.0f );	// sbNF
				glBegin( GL_TRIANGLES );
				glVertex3fv( points[triangles[uiIndexTriangle][0]] );
				glVertex3fv( points[triangles[uiIndexTriangle][1]] );
				glVertex3fv( points[triangles[uiIndexTriangle][2]] );
				glEnd();
			}
		}
	}
	// 
	if( m_bRenderLine )
	{
		glLineWidth( 2.0 );
		if( RM_RENDER == eRenderMode )
		{
			glColor3f( 0.0f, 0.5f, 0.5f );
		}
		if( RM_PICK_ELEMENTTYPE == eRenderMode )
		{
			glColor3f( 0.0f, 1.0f, 0.0f );
		}
		for( uiIndexTriangle = 0; uiIndexTriangle < uiCountTriangle; ++uiIndexTriangle )
		{
			for( ui3 = 0; ui3 < 3; ++ui3 )
			{
				if( RM_PICK_ELEMENTID == eRenderMode )
				{
					uiIndexLine = uiIndexTriangle * 3 + ui3;
					glColor3ub( GetRValue(uiIndexLine), GetGValue(uiIndexLine), GetBValue(uiIndexLine) );
				}
				glBegin( GL_LINES );
				glVertex3fv( points[triangles[uiIndexTriangle][( ui3 + 0 ) % 3]] );
				glVertex3fv( points[triangles[uiIndexTriangle][( ui3 + 1 ) % 3]] );
				glEnd();
			}
		}
		// sbN̕`
		if( RM_RENDER == eRenderMode )
		{
			if( RET_LINE == m_auiName_picked[1] )
			{
				uiIndexLine = m_auiName_picked[2];
				uiIndexTriangle = uiIndexLine / 3;
				ui3 = uiIndexLine % 3;
				glLineWidth( 5.0f );
				glColor3f( 0.0f, 1.0f, 1.0f );
				glBegin( GL_LINES );
				glVertex3fv( points[triangles[uiIndexTriangle][( ui3 + 0 ) % 3]] );
				glVertex3fv( points[triangles[uiIndexTriangle][( ui3 + 1 ) % 3]] );
				glEnd();
			}
		}
	}
	// _
	if( m_bRenderPoint )
	{
		glPointSize( 5.0 );
		if( RM_RENDER == eRenderMode )
		{
			glColor3f( 0.5f, 0.0f, 0.5f );
		}
		if( RM_PICK_ELEMENTTYPE == eRenderMode )
		{
			glColor3f( 0.0f, 0.0f, 1.0f );
		}
		for( uiIndexPoint = 0; uiIndexPoint < uiCountPoint; uiIndexPoint++ )
		{
			if( RM_PICK_ELEMENTID == eRenderMode )
			{
				glColor3ub( GetRValue(uiIndexPoint), GetGValue(uiIndexPoint), GetBValue(uiIndexPoint) );
			}
			glBegin( GL_POINTS );
			glVertex3fv( points[uiIndexPoint] );
			glEnd();
		}
		// sbN_̕`
		if( RM_RENDER == eRenderMode )
		{
			if( RET_POINT == m_auiName_picked[1] )
			{
				glPointSize( 10.0f );
				glColor3f( 1.0f, 0.0f, 1.0f );
				uiIndexPoint = m_auiName_picked[2];
				glBegin( GL_POINTS );
				glVertex3fv( points[uiIndexPoint] );
				glEnd();
			}
		}
	}

	glPopAttrib();	// Agr[g̕A
	return;
}

void CModelViewerRenderer::IdentifyPickRegionPixels( unsigned int uiCountPickRegionPixel, unsigned int aauiNamePickRegionPixel[][NAMEARRAYSIZE] )
{
	int  iId_selected = -1;
	unsigned int  uiElementType_selected = RET_FACE + 1;
	long lSquareDist_selected = ( 2 + PICKREGIONOFFSET ) * ( 2 + PICKREGIONOFFSET ) + ( 2 + PICKREGIONOFFSET ) * ( 2 + PICKREGIONOFFSET );
	long lSquareDist_current;
	int  x;
	int  y;
	for( unsigned int ui = 0; ui < uiCountPickRegionPixel; ui++ )
	{
		if( 0 == aauiNamePickRegionPixel[ui][1] )
		{ // f̊O
			continue;
		}

		if( !m_bPickPoint && RET_POINT == aauiNamePickRegionPixel[ui][1] )
		{	// _sbNOFF̏ꍇ́A_̓sbNłȂ
			continue;
		}
		if( !m_bPickLine && RET_LINE == aauiNamePickRegionPixel[ui][1] )
		{	// sbNOFF̏ꍇ́A̓sbNłȂ
			continue;
		}
		if( !m_bPickFace && RET_FACE == aauiNamePickRegionPixel[ui][1] )
		{	// ʃsbNOFF̏ꍇ́Aʂ̓sbNłȂ
			continue;
		}

		if( uiElementType_selected < aauiNamePickRegionPixel[ui][1] )
		{ // vf^CvIɁAD揇ʂႢ
			continue;
		}
		if( uiElementType_selected > aauiNamePickRegionPixel[ui][1] )
		{ // vf^CvIɁAD揇ʂႢ
			iId_selected = ui;
			uiElementType_selected = aauiNamePickRegionPixel[ui][1];
			x = ui % ( 1 + 2 * PICKREGIONOFFSET ) - PICKREGIONOFFSET;
			y = ui / ( 1 + 2 * PICKREGIONOFFSET ) - PICKREGIONOFFSET;
			lSquareDist_selected = x * x + y * y;
			continue;
		}
		// vf^CvIɁAD揇ʂꍇ́AsbN̈̒Sɋ߂̂DxB
		x = ui % ( 1 + 2 * PICKREGIONOFFSET ) - PICKREGIONOFFSET;
		y = ui / ( 1 + 2 * PICKREGIONOFFSET ) - PICKREGIONOFFSET;
		lSquareDist_current = x * x + y * y;
		if( lSquareDist_selected > lSquareDist_current )
		{
			iId_selected = ui;
			uiElementType_selected = aauiNamePickRegionPixel[ui][1];
			lSquareDist_selected = lSquareDist_current;
			continue;
		}
	}

	if( -1 == iId_selected )
	{
		return;
	}

	// O񃁃o̍XV
	memcpy( m_auiName_picked, aauiNamePickRegionPixel[iId_selected], NAMEARRAYSIZE * sizeof( unsigned int) );
}
